//+------------------------------------------------------------------+
//|                                              RisdyantoTrader.mq4 |
//|                                      Copyright  2008, Risdyanto |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Risdyanto"
#property link      ""

extern int    numBars2              =  3;
extern int    numBars               = 250;
extern int    maPeriod              = 10;
extern int    Lots                  =  1;
extern int    timeFrame             =  5;
extern int    timeFrame2            =  1;
double support;double resist;double support1;double resist1;double pivot;double fibo234;
double fibo764;double fibobl;double fibosl;double fibotarget1;double fibotarget2;
string trendType;string Signal;double range;double range2;
int fbbl,fbsl,fbbl1,fbsl1;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    ObjectCreate("lineSell",OBJ_HLINE,0,0,0);
    ObjectSet("lineSell",OBJPROP_COLOR,Yellow);
    ObjectSet("lineSell",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("lineBuy",OBJ_HLINE,0,0,0);
    ObjectSet("lineBuy",OBJPROP_COLOR,Lime);
    ObjectSet("lineBuy",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("lineSupport1",OBJ_HLINE,0,0,0);
    ObjectSet("lineSupport1",OBJPROP_COLOR,Red);
    ObjectSet("lineSupport1",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("lineResist1",OBJ_HLINE,0,0,0);
    ObjectSet("lineResist1",OBJPROP_COLOR,Blue);
    ObjectSet("lineResist1",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("linefibosell",OBJ_HLINE,0,0,0);
    ObjectSet("linefibosell",OBJPROP_COLOR,Magenta);
    ObjectSet("linefibosell",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("linefibobuy",OBJ_HLINE,0,0,0);
    ObjectSet("linefibobuy",OBJPROP_COLOR,Lavender);
     ObjectSet("linefibobuy",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("linepivot",OBJ_HLINE,0,0,0);
    ObjectSet("linepivot",OBJPROP_COLOR,White);
    
    ObjectCreate("linefibotarget1",OBJ_HLINE,0,0,0);
    ObjectSet("linefibotarget1",OBJPROP_COLOR,Blue);
    ObjectSet("linefibotarget1",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("linefibotarget2",OBJ_HLINE,0,0,0);
    ObjectSet("linefibotarget2",OBJPROP_COLOR,Red);
    ObjectSet("linefibotarget2",OBJPROP_STYLE,STYLE_DOT);
    
    ObjectCreate("linefibobl",OBJ_HLINE,0,0,0);
    ObjectSet("linefibobl",OBJPROP_COLOR,Red);
    
    ObjectCreate("linefibosl",OBJ_HLINE,0,0,0);
    ObjectSet("linefibosl",OBJPROP_COLOR,Blue);
    
    ObjectCreate("lblTrendType",OBJ_LABEL,0,0,0,0,0);
    ObjectSet("lblTrendType",OBJPROP_XDISTANCE,750);
    ObjectSet("lblTrendType",OBJPROP_YDISTANCE,20);
    ObjectSetText("lblTrendType","TrendType",20,"Tahoma",White);
   
    ObjectCreate("lblTrendType2",OBJ_LABEL,0,0,0,0,0);
    ObjectSet("lblTrendType2",OBJPROP_XDISTANCE,750);
    ObjectSet("lblTrendType2",OBJPROP_YDISTANCE,50);
    ObjectSetText("lblTrendType2","Signal",18,"Tahoma",White);

//----
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    ObjectsDeleteAll();
    
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  MarketAnalize();
  if(OrdersTotal()==0)
   CheckForOpen();
  else
   CheckForClose();
   
//----
   return(0);
  }

void MarketAnalize()
{
  support1=100000;
  resist1=0;
    for(int k = 1;k<=numBars;k++)
  {
    if(support1>iLow(Symbol(),timeFrame,k))
     support1 = iLow(Symbol(),timeFrame,k);
    if(resist1<iHigh(Symbol(),timeFrame,k))
     resist1 = iHigh(Symbol(),timeFrame,k);
     
      pivot       = (support1+resist1)/2;
      range       = resist1-support1;
      fibo234     = support1+(range*(23.4/100));
      fibo764     = resist1-(range*(23.4/100));
      fibotarget1 = resist1+(range*(161.8/100));
     fibotarget2 = support1-(range*(161.8/100));
    //  range2 = fibo764-fibo234;
    //  fibosl = fibo764 - (range2*(23.6/100));
     // fibobl= fibo234 +(range2*(23.6/100));
     // fbsl = fibosl-resist;
     // fbbl = support-fibobl;
  }  
  support =100000;
  resist = 0;
  for(int i = 1;i<=numBars2;i++)
  {  if(support > iLow(Symbol(),timeFrame2,i))
        support = iLow(Symbol(),timeFrame2,i);
     if(resist<iHigh(Symbol(),timeFrame2,i))
       resist  = iHigh(Symbol(),timeFrame2,i);
   }
  
  
  ObjectSet("lineSell",OBJPROP_PRICE1,support);
  ObjectSet("lineBuy",OBJPROP_PRICE1,resist);
  ObjectSet("lineSupport1",OBJPROP_PRICE1,support1);
  ObjectSet("lineResist1",OBJPROP_PRICE1,resist1);
  ObjectSet("linefibosell",OBJPROP_PRICE1,fibo764);
  ObjectSet("linefibobuy",OBJPROP_PRICE1,fibo234);
  ObjectSet("linefibotarget1",OBJPROP_PRICE1,fibotarget1);
  ObjectSet("linefibotarget2",OBJPROP_PRICE1,fibotarget2);
// ObjectSet("linepivot",OBJPROP_PRICE1,pivot);
  ObjectSet("linefibobl",OBJPROP_PRICE1,fibobl);
  ObjectSet("linefibosl",OBJPROP_PRICE1,fibosl);
 
  
  if (Bid < fibo234 ) {Signal = "Reversal-Buy";}
  if (Bid > fibo764 ) {Signal = "Reversal-Sell";}
  if ((Open[0] > fibo234) && (Open[0] < fibo764)) {Signal = "Trading";}
  
  double ma = iMA(Symbol(),timeFrame,maPeriod,0,MODE_SMA,PRICE_CLOSE,0);
  if(Ask>ma) { trendType = "Tick-Up";  }
  if(Bid<ma) { trendType = "Tick-Down";  }
   ObjectSetText("lblTrendType",trendType);
   ObjectSetText("lblTrendType2",Signal);
  
  
}

void CheckForOpen()

{
   if ((trendType=="Tick-Down") && (Signal=="Reversal-Buy"))  
      {if (Ask > support) OrderSend(Symbol(),OP_BUY,Lots,Ask,0,support1,fibotarget1);}
   
   if ((trendType=="Tick-Up") && (Signal=="Reversal-Buy"))  
      {if (Ask > support) OrderSend(Symbol(),OP_BUY,Lots,Ask,0,support1,fibotarget1);}
  
   if ((trendType=="Tick-Down") && (Signal=="Trading")) 
      {if (Bid < support) OrderSend(Symbol(),OP_SELL,Lots,Bid,0,resist1,fibotarget2);}
      
   if (trendType=="Tick-Down") 
      {if (Bid < support) OrderSend(Symbol(),OP_SELL,Lots,Bid,0,resist1,fibotarget2);}
      
   if ((trendType=="Tick-Up") && (Signal == "Reversal-Sell")) 
      {if (Bid > support) OrderSend(Symbol(),OP_SELL,Lots,Bid,0,resist1,fibotarget2); }
   
    if ((trendType=="Tick-Down") && (Signal == "Reversal-Sell")) 
      {if (Bid > support) OrderSend(Symbol(),OP_SELL,Lots,Bid,0,resist1,fibotarget2); }
 
   if ((trendType=="Tick-Up") && (Signal == "Trading"))
      {if (Ask > resist)  OrderSend(Symbol(),OP_BUY,Lots,Ask,0,support1,fibotarget1);}
   
   if (trendType=="Tick-Up") 
      {if (Ask > resist)  OrderSend(Symbol(),OP_BUY,Lots,Ask,0,support1,fibotarget1);}
  
}

void CheckForClose()
{
 OrderSelect(0,SELECT_BY_POS);
 
if(OrderProfit()>0)
 {
   if(OrderType()==OP_BUY)
   {
     if(Bid<support) OrderClose(OrderTicket(),OrderLots(),Bid,3);
   }
   if(OrderType()==OP_SELL)
   { 
      if(Ask>resist)  OrderClose(OrderTicket(),OrderLots(),Ask,3);
   }
 }
 
 //if(OrderProfit()<0)
// {
 //  if(OrderType()==OP_BUY)
 //  {
 //    if(Bid<support) OrderClose(OrderTicket(),OrderLots(),Bid,3);
 //  }
 //  if(OrderType()==OP_SELL)
 //  { 
 //     if(Ask>resist)  OrderClose(OrderTicket(),OrderLots(),Ask,3);
  // }
 //}
 
//------------------------------------------------------------------------------------------------
 if(OrderType()==OP_BUY)
 {
  //if((Ask>OrderOpenPrice()+Point*20)&&(OrderStopLoss()<(OrderOpenPrice()+Point*15)))
  //  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*15,OrderTakeProfit(),0,Blue);
   if((Ask>OrderOpenPrice()+Point*40)&&(OrderStopLoss()<(OrderOpenPrice()+Point*30)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*30,OrderTakeProfit(),0,Blue);    
   if((Ask>OrderOpenPrice()+Point*100)&&(OrderStopLoss()<(OrderOpenPrice()+Point*90)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Point*90,OrderTakeProfit(),0,Blue);
 }
 if(OrderType()==OP_SELL)
 {
  // if((Bid<OrderOpenPrice()-Point*20)&&(OrderStopLoss()>(OrderOpenPrice()-Point*15)))
  //  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*15,OrderTakeProfit(),0,Blue);     
   if((Bid<OrderOpenPrice()-Point*40)&&(OrderStopLoss()>(OrderOpenPrice()-Point*30)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*30,OrderTakeProfit(),0,Blue);     
   if((Bid<OrderOpenPrice()-Point*100)&&(OrderStopLoss()>(OrderOpenPrice()-Point*90)))
    OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Point*90,OrderTakeProfit(),0,Blue);     
 }
}


